src/Entity/Adoption.php
<?php

namespace App\Entity;

use App\Repository\AdoptionRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=AdoptionRepository::class)
 */
class Adoption
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="text")
     */
    private $description;

    /**
     * @ORM\OneToMany(targetEntity=Contact::class, mappedBy="adoption")
     */
    private $contacts;

    /**
     * @ORM\OneToMany(targetEntity=Dog::class, mappedBy="adoption")
     */
    private $dogs;

    public function __construct()
    {
        $this->contacts = new ArrayCollection();
        $this->dogs = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    /**
     * @return Collection|Contact[]
     */
    public function getContacts(): Collection
    {
        return $this->contacts;
    }

    public function addContact(Contact $contact): self
    {
        if (!$this->contacts->contains($contact)) {
            $this->contacts[] = $contact;
            $contact->setAdoption($this);
        }

        return $this;
    }

    public function removeContact(Contact $contact): self
    {
        if ($this->contacts->removeElement($contact)) {
            // set the owning side to null (unless already changed)
            if ($contact->getAdoption() === $this) {
                $contact->setAdoption(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Dog[]
     */
    public function getDogs(): Collection
    {
        return $this->dogs;
    }

    public function addDog(Dog $dog): self
    {
        if (!$this->dogs->contains($dog)) {
            $this->dogs[] = $dog;
            $dog->setAdoption($this);
        }

        return $this;
    }

    public function removeDog(Dog $dog): self
    {
        if ($this->dogs->removeElement($dog)) {
            // set the owning side to null (unless already changed)
            if ($dog->getAdoption() === $this) {
                $dog->setAdoption(null);
            }
        }

        return $this;
    }

    public function __toString()
    {
        $string = $this->getName();

        if (!empty($this->getDogs())){
            $string .= ' (';
            foreach ($this->getDogs() as $key => $dog){
                $string .= $dog->getName();
                if ($key < count($this->getDogs()) - 1){
                    $string .= ', ';
                }
                $string .= ')';
            }
        }

        return $string;
    }
}

src/Entity/Dog.php
<?php

namespace App\Entity;

use App\Repository\DogRepository;
use DateTime;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=DogRepository::class)
 */
class Dog
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="date", nullable=true)
     */
    private $birthDate;

    /**
     * @ORM\Column(type="text")
     */
    private $description;

    /**
     * @ORM\ManyToOne(targetEntity=Adoption::class, inversedBy="dogs")
     */
    private $adoption;

    /**
     * @ORM\ManyToMany(targetEntity=Breed::class, mappedBy="dogs")
     */
    private $breeds;

    /**
     * @ORM\OneToMany(targetEntity=Image::class, mappedBy="dog")
     */
    private $images;

    public function __construct()
    {
        $this->breeds = new ArrayCollection();
        $this->images = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getBirthDate(): ?\DateTimeInterface
    {
        return $this->birthDate;
    }

    public function setBirthDate(?\DateTimeInterface $birthDate): self
    {
        $this->birthDate = $birthDate;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getAdoption(): ?Adoption
    {
        return $this->adoption;
    }

    public function setAdoption(?Adoption $adoption): self
    {
        $this->adoption = $adoption;

        return $this;
    }

    /**
     * @return Collection|Breed[]
     */
    public function getBreeds(): Collection
    {
        return $this->breeds;
    }

    public function addBreed(Breed $breed): self
    {
        if (!$this->breeds->contains($breed)) {
            $this->breeds[] = $breed;
            $breed->addDog($this);
        }

        return $this;
    }

    public function removeBreed(Breed $breed): self
    {
        if ($this->breeds->removeElement($breed)) {
            $breed->removeDog($this);
        }

        return $this;
    }

    /**
     * @return Collection|Image[]
     */
    public function getImages(): Collection
    {
        return $this->images;
    }

    public function addImage(Image $image): self
    {
        if (!$this->images->contains($image)) {
            $this->images[] = $image;
            $image->setDog($this);
        }

        return $this;
    }

    public function removeImage(Image $image): self
    {
        if ($this->images->removeElement($image)) {
            // set the owning side to null (unless already changed)
            if ($image->getDog() === $this) {
                $image->setDog(null);
            }
        }

        return $this;
    }

    public function getAge(): ?int{
        if (empty($this->getBirthDate())){
            return null;
        }

        $now = new DateTime();

        $diff = $this->getBirthDate()->diff($now, true);

        return $diff->y;
    }
}

src/Controller/AdoptionController.php
<?php

namespace App\Controller;

use App\Entity\Adoption;
use App\Repository\AdoptionRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/annonces")
 */
class AdoptionController extends AbstractController
{
    /**
     * @Route("/", name="adoption_index")
     */
    public function announces(AdoptionRepository $adoptionRepository): Response
    {
        $adoptions = $adoptionRepository->findAll();

        return $this->render('adoption/adoption.html.twig',
            ['adoptions' => $adoptions]);
    }

    /**
     * @Route("/{id}", name="adoption_show")
     */
    public function show(Adoption $adoption): response{

        return $this->render('adoption/show.html.twig',[
            'adoption' => $adoption,
        ]);
    }
}

templates/adoption/adoption.html.twig
{% extends 'base.html.twig' %}

{% block title %}Chiens à l'adoption{% endblock %}

{% block body %}
    <h1>Chiens à l'adoption</h1>
    {% for adoption in adoptions %}
        <div class="card text-center">
            <h3 class="card-header">
                <a href="{{ path('adoption_show', {id: adoption.id,})}}">
                    {{ adoption.name }}
                </a>
            </h3>
            <div class="card-body">
                <p class="card-text">
                    {{ adoption.description }}
                </p>
                {% for dog in adoption.dogs %}
                    <h4>
                        {{ dog.name }}
                        {% if dog.birthDate %}
                            ({{ dog.age }} ans)
                        {% endif %}
                    </h4>
                    {% for image in dog.images %}
                        <img src="{{ image.path }}" alt="" class="card-img-top w-25 h-25">
                    {% endfor %}
                    <p>
                        {{ dog.description }}
                    </p>
                {% endfor %}
            </div>
            <div class="card-footer text-muted">

            </div>
        </div>
    {% endfor %}
{% endblock %}

templates/adoption/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{ adoption.name }}{% endblock %}

{% block body %}
    <div class="container-fluid text-center">
        <h1>{{ adoption.name }}</h1>
        <p>
            {{ adoption.description }}
        </p>
        {% for dog in adoption.dogs %}
            <h4>
                {{ dog.name }}
                {% if dog.birthDate %}
                    ({{ dog.age }} ans)
                {% endif %}
            </h4>
            {% for image in dog.images %}
                <img src="{{ image.path }}" alt="" class="card-img-top w-25 h-25">
            {% endfor %}
            <p>
                {{ dog.description }}
            </p>
        {% endfor %}
        <a href="{{ path('default_contact_for_adoption', { id: adoption.id}) }}">Nous contacter</a>
    </div>
{% endblock %}